import Head from 'next/head';
import { useState } from 'react';

import { server } from '../config';

import { Header } from '../components/Header/';
import { Footer } from '../components/Footer/';
import { Operator } from '../components/Operator/';
import { ConsultationForm } from '../components/ConsultationForm/';
import { Filter } from '../components/Filter/';
import { SortPopup } from '../components/SortPopup/';
import { HousesBoard } from '../components/HousesBoard/';
import ReactPaginate from 'react-paginate';

export default function Home({ listings }) {
  const [isFilter, setIsFilter] = useState(false);
  const [listingsFilter, setListingsFilter] = useState([]);

  const [housesPerPage] = useState(10);
  const [currentPage, setCurrentPage] = useState(0);

  const [minValue, setMinValue] = useState(0);
  const [maxValue, setMaxValue] = useState(999999999);
  const [type, setType] = useState('');
  const [checkBasement, setCheckBasement] = useState(false);

  const sortList = [
    { name: 'id', type: 'id' },
    { name: 'площади', type: 'square' },
    { name: 'цене', type: 'price' },
  ];

  const [sortItem, setSortItem] = useState(sortList[0].name);

  const filter = [];

  //сброс параметров фильтрации и сортировки
  const onResetParam = (data, isFilter) => {
    setListingsFilter(data);
    setIsFilter(isFilter);
    handlePageChange({ selected: 0 });
    setSortItem(sortList[0].name);
  };

  //фильтрация по мин.цене, макс.цене, наличию подвала и типу жилья.
  const onFilterListings = (minValue, maxValue, checkBasement, type) => {
    let filter = [];
    if (type) {
      filter = listings.filter((i) => {
        return i.price < maxValue && i.price > minValue && i.hasBasement == checkBasement && i.type == type;
      });
    } else {
      filter = listings.filter((i) => {
        return i.price < maxValue && i.price > minValue && i.hasBasement == checkBasement;
      });
    }
    onResetParam(filter, true);
  };

  //сброс фильтра
  const onResetFilter = () => {
    const filter = listings;
    onResetParam(filter, false);
  };

  let listingsMap = [];
  
  if (!isFilter) {
    listingsMap = listings;
  } else {
    listingsMap = listingsFilter;
  }

  const indexOfLastListing = currentPage * housesPerPage;
  const indexOfFirstListing = indexOfLastListing - housesPerPage;
  let currentListings = listingsMap.slice(indexOfFirstListing, indexOfLastListing);

  //сортировка
  const onSelectSortType = (index) => {
    if (isFilter == false) {
      listingsMap = listings;
    } else {
      listingsMap = listingsFilter;
    }
    if (index.type == 'price') {
      listingsMap = listingsMap.sort((a, b) => {
        return a.price - b.price;
      });
      setSortItem(sortList[2].name);
    }
    if (index.type == 'id') {
      listingsMap = listingsMap.sort((a, b) => {
        return a.id - b.id;
      });
      setSortItem(sortList[0].name);
    }
    if (index.type == 'square') {
      listingsMap = listingsMap.sort((a, b) => {
        return a.square - b.square;
      });
      setSortItem(sortList[1].name);
    }
    currentListings = listingsMap.slice(indexOfFirstListing, indexOfLastListing);
    handlePageChange({ selected: 0 });
  };

  const handlePageChange = ({ selected }) => {
    setCurrentPage(selected + 1);
  };

  // количество страниц
  const pageNumberListings = listingsMap.length / housesPerPage;

  return (
    <div className="container">
      <Head>
        <title>MyApp</title>
        <meta name="description" content="Generated by create next app" />
        <link rel="icon" href="/favicon.ico" />
      </Head>

      <Header />

      <main>
        <section className="search">
          <h1>Квартиры в Москве </h1>

          <div className="content">
            <div className="content__main">
              <Filter
                maxValue={maxValue}
                minValue={minValue}
                checkBasement={checkBasement}
                type={type}
                onFilterListings={onFilterListings}
                onResetFilter={onResetFilter}
                setMinValue={setMinValue}
                setMaxValue={setMaxValue}
                setCheckBasement={setCheckBasement}
                setType={setType}
              />

              <SortPopup activeSortType={sortItem} items={sortList} onClickSortType={onSelectSortType} />

              <ReactPaginate
                pageCount={pageNumberListings}
                pageRangeDisplayed={2}
                marginPagesDisplayed={2}
                initialPage={currentPage}
                onPageChange={handlePageChange}
                forcePage={currentPage - 1}
                containerClassName="pagination"
                pageClassName="pagination__item"
                activeClassName="pagination__item pagination__item--active"
                activeLinkClassName="pagination__item selected"
                previousClassName="pagination__next-prev"
                nextClassName="pagination__next-prev"
              />

              <HousesBoard currentListings={currentListings} />
            </div>

            <div className="content__contacts">
              <Operator />
              <ConsultationForm />
            </div>
          </div>
        </section>
      </main>
      <Footer />
    </div>
  );
}

export async function getStaticProps(context) {
  const response = await fetch(`${server}/houses.json`);
  const listings = await response.json();

  return {
    props: { listings },
  };
} 
